﻿// SageTV Gadget v2.1

// Strings
var TITLE_TEXT = "Recording Schedule";
var TITLE2_TEXT = "Available Clients";
var LOAD_FLYOUT = "<div style=\"margin-left:10px\">Loading...</div>";
var DETAILS_URL = "DetailedInfo?AiringId=";
var ERROR1 = "<div style=\"margin-left:10px\">NA - Check network connection, server, and settings.</div>";

// Global variables
var gURL = "";
var gDF = "";
var gTF = "";
var gLogoURL = "";
var gShowLogos = false;
var gAddPadding = false;
var gClients = null;
var gXReq1 = null;
var gXReq2 = null;

function Init(address, df, tf, chlogo, padding)
{
    gURL = address;
    gTF = tf;
    gDF = df;
    gLogoURL = chlogo;
    gShowLogos = (chlogo != "");
    gAddPadding = padding;
}

function Init2(address)
{
    gURL = address;
}

function DownloadSchedule()
{
    // Try to connect to Web Server
    TITLE.innerText = TITLE_TEXT;
    FLYCONTENT.innerHTML = LOAD_FLYOUT;
    
    try
    {

        if (gXReq1 == null)
        {
            gXReq1 = new XMLHttpRequest();
            gXReq1.onreadystatechange = FillSchedule;
        }
        else if (gXReq1.readyState != 4)
            return;

        gXReq1.open("GET", gURL, true);
        gXReq1.send();
    }
    catch( err)
    {
        ReportConnectionError();
      //  MAINCONTENT.innnerText = err;
    }
    
}

// Generate the html for the Flyout
function FillSchedule()
{
    if (gXReq1.readyState != 4)
        return;

    try
    {
        // Generate HTML
        var res = eval('(' + gXReq1.responseText + ')');
        var htmlStr = "<table id=\"RECORDTABLE\">";
        var prevDate = "";
        var curDate = "";
        var now = new Date();
        var airings = res.Result;
        for (var i = 0; i < airings.length; i++)
        {

            // Group by day
            var start = new Date(gAddPadding ? airings[i].ScheduleStartTime : airings[i].AiringStartTime);
            var stop = new Date(gAddPadding ? airings[i].ScheduleEndTime : airings[i].AiringEndTime);
            curDate = start.format(gDF);
            if (curDate != prevDate)
            {
                htmlStr += "<tr><td class=\"DateRow\" colspan=\"4\">" + curDate + "</td></tr>";
                prevDate = curDate;
            }


            if (start < now)
                htmlStr += "<tr style=\"color:#FF0000\">";
            else
                htmlStr += "<tr>";

            if (airings[i].AiringTitle != null)
            {
                htmlStr += "<td class=\"TimeColumn\">" + start.format(gTF) + "<br/>- " + stop.format(gTF) + "</td>";
                if (gShowLogos)
                    htmlStr += "<td class=\"ChLogoColumn\"><img class=\"ChLogoImg\" src=\"" + gLogoURL + airings[i].Channel.StationID + "?type=small\"></td>";
                var linkstr = " onclick=\"OpenAiring(" + airings[i].AiringID + ")\"";
                var hoverstr = " onmouseover=\"Underline(this)\" onmouseout=\"DeUnderline(this)\"";
                htmlStr += "<td class=\"ChannelColumn\">" + airings[i].AiringChannelName + "<br/>" + airings[i].AiringChannelNumber + "</td>" + "<td class=\"TitleColumn\" title=\"" + airings[i].Show.ShowDescription + "\"" + linkstr + hoverstr + ">" + airings[i].AiringTitle + "</td>";
            }
            htmlStr += "</tr>";
        }


        htmlStr += "</table>";

        FLYCONTENT.innerHTML = htmlStr;
    }
    catch (err)
    {
        // document.body.innerHTML = err.Description;
        ReportConnectionError();
    }

}

function DownloadClients()
{
    // Try to connect to Web Server
    TITLE.innerText = TITLE2_TEXT;
    FLYCONTENT.innerHTML = LOAD_FLYOUT;

    try
    {

        if (gXReq2 == null)
        {
            gXReq2 = new XMLHttpRequest();
            gXReq2.onreadystatechange = FillClients;
        }
        else if (gXReq2.readyState != 4)
            return;

        gXReq2.open("GET", gURL, true);
        gXReq2.send();
    }
    catch (err)
    {
        ReportConnectionError();
        //  MAINCONTENT.innnerText = err;
    }

}

// Generate the html for the Flyout
function FillClients()
{
    if (gXReq2.readyState != 4)
        return;

    try
    {
        // Generate HTML string
        var res = eval('(' + gXReq2.responseText + ')');
        var htmlStr = "";
        gClients = res.Result;
        for (var i = 0; i < gClients.length; i++)
        {
            if (!IsConnected(gClients[i]))
            {
                var name = System.Gadget.document.parentWindow.GetClientName(gClients[i]);
                htmlStr += "<div class=\"ClientItem\" onmouseover=\"HighlightClient(this)\" onmouseout=\"UnHighlightClient(this)\" onclick=\"SelectClient('" + gClients[i] + "')\">Connect to " + (name != "" ? name + " (" + gClients[i] + ")" : gClients[i]) + "</div>";
            }
        }

        // Disconnect from current
        var current = System.Gadget.document.parentWindow.gClient;
        if (current != "")
        {
            var name = System.Gadget.document.parentWindow.GetClientName(current);
            htmlStr += "<div class=\"ClientItem\" onmouseover=\"HighlightClient(this)\" onmouseout=\"UnHighlightClient(this)\" onclick=\"SelectClient('" + current + "')\">Disconnect from " + (name != "" ? name + " (" + current + ")" : current) + "</div>";
        }

        // Rename
        if( gClients.length > 0)
            htmlStr += "<br/><br/><div class=\"RenameLink\" onmouseover=\"Underline(this)\" onmouseout=\"DeUnderline(this)\" onclick=\"ShowRename()\">Rename Clients...</div>";

        FLYCONTENT.innerHTML = htmlStr;
    }
    catch (err)
    {
        // document.body.innerHTML = err.Description;
        ReportConnectionError();
    }
}

function IsConnected(client)
{
    return client == System.Gadget.document.parentWindow.gClient;
}

function ShowRename(client)
{
    var htmlStr = "<div>Enter alternate names for the clients and click Apply:</div>";
    for (var i = 0; i < gClients.length; i++)
    {
        var name = System.Gadget.document.parentWindow.GetClientName(gClients[i]);
        htmlStr += "<br/><br/><div class=\"RenameArea\">" + gClients[i] + ": <input type=\"text\" style=\"width: 50%\" id=\"" + gClients[i] + "\" value=\"" + name + "\"</input></div>";
    }

    htmlStr += "<br/><br/><div style=\"width:25%\"><div class=\"RenameLink\" onmouseover=\"Underline(this)\" onmouseout=\"DeUnderline(this)\" onclick=\"ApplyRename()\" style=\"float:left\">\Apply</div>";
    htmlStr += "<div class=\"RenameLink\" onmouseover=\"Underline(this)\" onmouseout=\"DeUnderline(this)\" onclick=\"DownloadClients()\" style=\"float:right\">\Cancel</div></div>";
    FLYCONTENT.innerHTML = htmlStr;
}

function ApplyRename()
{
    try
    {
        var str = "";
        for (var i = 0; i < gClients.length; i++)
        {
            if (i > 0)
                str += ";";

            if (gClients[i].charAt(0) == '/')
                str += gClients[i].split(':')[0];
            else
                str += gClients[i];

            str += ";";
            var tb = document.getElementById(gClients[i]);
            if (tb != null)
                str += tb.value;
        }

        System.Gadget.Settings.writeString("ClientNames", str);
    }
    catch (err)
    {
    }
    DownloadClients();
}

function OpenAiring( airingId)
{
    try
    {
        var linkStr = "";
        var index = gURL.lastIndexOf('/');
        if (index > 0)
            linkStr = gURL.substring(0, index - 1) + "/" + DETAILS_URL + airingId;
        System.Shell.execute(linkStr, "");
    }
    catch (err)
    {
    }
}

function Underline( cell)
{
  cell.style.textDecoration = "underline";
}

function DeUnderline( cell)
{
  cell.style.textDecoration = "none";
}

function HighlightClient(cell)
{
    cell.style.backgroundColor = "#DDDDDD";
}

function UnHighlightClient(cell)
{
    cell.style.backgroundColor = "#E6F2FF";
}

function SelectClient(client)
{
    System.Gadget.Flyout.show = false;
    if (IsConnected(client))
    {
        System.Gadget.document.parentWindow.gClient = "";
        System.Gadget.document.parentWindow.SetClient( "");
    }
    else
        System.Gadget.document.parentWindow.SetClient( client);
}

function ReportConnectionError()
{
    FLYCONTENT.innerHTML = ERROR1;
}

