﻿// SageTV Gadget v2.1

// Strings
var ERROR1 = "<div style=\"margin-left:10px\">NA - Check network connection, server, and settings.</div>";
var CONNECTING = "<div style=\"margin-left:10px\">Connecting...</div>";
var HOME_URL = "/sage/Home";
var CURRENT_URL = "/sage/Home?xml=currrecording";
var SCHEDULE_URL = "/sagex/api?c=GetScheduledRecordings&encoder=json";
var STATUS_URL = "/sagex/api?c=GadgetUtils:GetSystemStatus";
var CLIENTS_URL = "/sagex/api?c=GadgetUtils:GetAllConnections&encoder=json";
var MEDIAFILE_URL = "/sagex/api?c=GetCurrentMediaFile&encoder=json";
var NP_URL = "/sagex/api?c=GadgetUtils:GetNowPlayingInfo";
var PP_URL = "/sagex/api?c=PlayPause";
var NEXT_URL = "/sagex/api?c=ChannelUp";
var PREV_URL = "/sagex/api?c=ChannelDown";
var SAGE_EXE = "SageTV\\SageTV.exe";
var CLIENT_EXE = "SageTV\\SageTVClient.exe";
var REG_INSTALL = "HKLM\\Software\\Frey Technologies\\LastInstallDir";
var REG_INSTALL_64 = "HKLM\\Software\\Wow6432Node\\Frey Technologies\\LastInstallDir";
var CHLOGO_URL = "/sagex/media/logo/";
var MSG_URL = "/sage/SystemMessages";
var MSG_RSS_URL = "/sage/public/Rss/SystemMessages";
var IMG_INFO = "images/Alert1.png";
var IMG_WARNING = "images/Alert2.png";
var IMG_ERROR = "images/Alert3.png";

// Global variables
var gInstallDir = "d:\\program files\\sagetv\\";
var gBackgroundImg  = "\\images\\Background.jpg";
var gBorder = "";
var gServer = "server";
var gPort = "8080";
var gUpdateMinutes = 5;
var gLaunchType = 0;
var gDateFormat = "ddd mmm dd";
var gTimeFormat = "h:MM TT";
var gUser = "sage";
var gPass = "frey";
var gNumRecs = 3;
var gTotalHeight = 145;
var gTotalWidth = 130;
var gShowLogos = false;
var gAddPadding = false;
var gShowDisk = true;
var gShowNP = false;
var gClient = "";
var gNPState = 0;
var gNPMediaID = "";
var gNPUpdateSec = 5;
var gNPString = "mf.MediaTitle";
var gNPDetailsHeight = 55;
var gNPConnectSec = 0;
var gRecString = "\"<div class='RecordingTitle'>\" + airing.AiringTitle + \"</div><div class='RecordingSub'>\" + (isRecordingNow ? \"-\" + stop.format(gTimeFormat) : (date != today ? date : start.format(gTimeFormat))) + \" \" + airing.AiringChannelName + \" (\" + airing.AiringChannelNumber + \")</div>\"";
var gXReq1 = null;
var gXReq2 = null;
var gXReq3 = null;
var gXReq4 = null;
var gXReq5 = null;
var gXReq6 = null;

// Constants
var gBaseHeight = 23;
var gHeaderHeight = 18;
var gRecHeight = 30;
var gDiskHeight = 49;
var gNPBaseHeight = 37;
var gNRText = "------";

function loadMain()
{
    // Setttings page
    System.Gadget.settingsUI = "settings.html";
    System.Gadget.onSettingsClosed = SettingsClosed;
    
    // Flyout
    System.Gadget.Flyout.file = "flyout.html";
    
    // Images
    gBackgroundImg = System.Gadget.path + gBackgroundImg;

    // Make control bar
    bar.innerHTML = "prev play pause next - reveal";
    makeBar(bar);
    bar_play.style.display = "";
    bar_pause.style.display = "none";
    
    // Apply current settings
    RECIMG.style.visibility = "hidden";
    MSGIMG.style.visibility = "hidden";
    gBorder = MAINCONTENT.style.borderStyle;
    ApplySettings();
}



function Launch()
{
    switch( gLaunchType)
    {
    case 0:
        System.Shell.execute( "http://" + gServer + ":" + gPort + HOME_URL, "");
        break;
    case 1:
        System.Shell.execute("http://" + gUser + ":" + gPass + "@" + gServer + ":" + gPort + HOME_URL, "");
        break;
    case 2:
        System.Shell.execute( GetInstallDirFromReg() + SAGE_EXE, "");
       break;
    case 3:
        System.Shell.execute( GetInstallDirFromReg() + CLIENT_EXE, "");
        break; 
    }
}

function LaunchMsg()
{
    switch( gLaunchType)
    {
    case 0:
        System.Shell.execute( "http://" + gServer + ":" + gPort + MSG_URL, "");
        break;
    case 1:
        System.Shell.execute("http://" + gUser + ":" + gPass + "@" + gServer + ":" + gPort + MSG_URL, "");
        break;
    case 2:
        System.Shell.execute( GetInstallDirFromReg() + SAGE_EXE, "");
       break;
    case 3:
        System.Shell.execute( GetInstallDirFromReg() + CLIENT_EXE, "");
        break; 
    }
}


function ConnectToSage()
{   
    // Try to connect to Web Server
    CURRENT.innerHTML = CONNECTING;
    RECIMG.style.visibility = "hidden";
    MSGIMG.style.visibility = "hidden";
    
    try
    {
        if (gXReq1 == null)
        {
            gXReq1 = new XMLHttpRequest();
            gXReq1.onreadystatechange = FillRecordings;
        }
        else if (gXReq1.readyState != 4)
            return;

        gXReq1.open("GET", "http://" + gUser + ":" + gPass + "@" + gServer + ":" + gPort + SCHEDULE_URL + "&size=" + gNumRecs + "&NoCache=" + Math.random(), true)
        gXReq1.send();
        
    }
    catch( err)
    {
        ReportConnectionError();
        ReportConnectionError2();
       // CURRENT.innerHTML = err;
    }

}

function FillRecordings()
{
    try
    {
        // Make sure it was properly loaded
        if (gXReq1.readyState != 4)
            return;

        var res = eval('(' + gXReq1.responseText + ')');

        // List current recordings
        var sHTML = "";
        var now = new Date();
        var today = now.format(gDateFormat);
        var bRecording = false;
        var airings = res.Result;
        for (var i = 0; i < gNumRecs; i++)
        {
            if (i < airings.length && airings[i] != null && airings[i].AiringTitle != null)
            {
                try
                {
                    var airing = airings[i];
                    var start = new Date(gAddPadding ? airings[i].ScheduleStartTime : airings[i].AiringStartTime);
                    var stop = new Date(gAddPadding ? airings[i].ScheduleEndTime : airings[i].AiringEndTime);
                    var isRecordingNow = (start < now);
                    var date = start.format(gDateFormat);
                    if (isRecordingNow)
                    {
                        bRecording = true;
                        sHTML += "<div class=\"RecordingText\" style=\"overflow:hidden;height:" + gRecHeight + "px\">";
                    }
                    else
                    {
                        sHTML += "<div style=\"overflow:hidden;height:" + gRecHeight + "px\">";
                    }

                    sHTML += eval('(' + gRecString + ')') + "</div>";
                }
                catch (err)
                {
                    sHTML += "<div class=\"RecordingTitle\">" + err.name + "</div>" + "<div class=\"RecordingSub\">" + err.description + "</div>";
                }


//                if (start < now)
//                {
//                    bRecording = true;
//                    sHTML += "<div class=\"RecordingTitle RecordingText\"" + " title=\"" + airings[i].AiringTitle + " on " + airings[i].AiringChannelName + " until " + stop.format(gTimeFormat) + "\">" + airings[i].AiringTitle + "</div>";
//                    sHTML += "<div class=\"RecordingSub RecordingText\" >-" + stop.format(gTimeFormat) + " " + airings[i].AiringChannelName + " (" + airings[i].AiringChannelNumber + ")</div>";
//                }
//                else
//                {
//                    day = start.format(gDateFormat);
//                    sHTML += "<div class=\"RecordingTitle\" title=\"" + airings[i].AiringTitle + " on " + airings[i].AiringChannelName + " at " + start.format(gTimeFormat) + "\">" + airings[i].AiringTitle + "</div>";
//                    sHTML += "<div class=\"RecordingSub\">" + (day != today ? day : start.format(gTimeFormat)) + " " + airings[i].AiringChannelName + " (" + airings[i].AiringChannelNumber + ")</div>";
//                }
            }
            else
            {
                sHTML += "<div class=\"RecordingTitle\">" + gNRText + "</div>" + "<div class=\"RecordingSub\"></div>";
            }
        }

        if (bRecording)
            RECIMG.style.visibility = "visible";

        CURRENT.innerHTML = sHTML;

        // System status
        if (gXReq2 == null)
        {
            gXReq2 = new XMLHttpRequest();
            gXReq2.onreadystatechange = FillSystemStatus;
        }
        else if (gXReq2.readyState != 4)
            return;

        gXReq2.open("GET", "http://" + gUser + ":" + gPass + "@" + gServer + ":" + gPort + STATUS_URL + (gShowDisk ? "&1=true" : "") + "&NoCache=" + Math.random(), true);
        gXReq2.send();
    }
    catch (err)
    {
        ReportConnectionError();
        ReportConnectionError2();
        // CURRENT.innerHTML = err;
    }
}

function FillSystemStatus()
{
    try
    {
        // Make sure it was properly loaded
        if (gXReq2.readyState != 4)
            return;

        var jsonStr = gXReq2.responseText;
        var begin = jsonStr.indexOf('{');
        var end = jsonStr.lastIndexOf('}');
        var res = eval('(' + jsonStr.substring(begin,end+1) + ')');

        if (gShowDisk)
        {
            var used = Math.round(res.UsedDisk / 100000000) / 10;
            var avail = Math.round(res.AvailDisk / 100000000) / 10;
            var total = Math.round((res.UsedDisk + res.AvailDisk) / 100000000) / 10;
            DISKTEXT.innerText = avail + " / " + total + " GB";
            DISKUSED.style.width = (used * 100) / total + "%";
        }

        // System messages
        if (res.AlertLevel == 0) 
        {
            MSGIMG.style.visibility = "hidden";
        }
        else if (res.AlertLevel == 1) 
        {
            MSGIMG.style.visibility = "visible";
            MSGIMG.src = IMG_INFO;
        }
        else if (res.AlertLevel == 2) 
        {
            MSGIMG.style.visibility = "visible";
            MSGIMG.src = IMG_WARNING;
        }
        else if (res.AlertLevel == 3) 
        {
            MSGIMG.style.visibility = "visible";
            MSGIMG.src = IMG_ERROR;
        }
       
    }
    catch( err)
    {
        ReportConnectionError2();
       // DISKTEXT.innerHTML = err;
    }
}

function PollNP()
{
    // Try to connect to Web Server
    try
    {
        if (gXReq3 == null)
        {
            gXReq3 = new XMLHttpRequest();
            gXReq3.onreadystatechange = FillNowPlaying;
        }
        else if (gXReq3.readyState != 4)
            return;

        gXReq3.open("GET", "http://" + gUser + ":" + gPass + "@" + gServer + ":" + gPort + NP_URL + "&1=" + gClient + "&NoCache=" + Math.random(), true);
        gXReq3.send();

    }
    catch (err)
    {
        SetClient("");
        // ReportConnectionError3();
    }
 }

 function FillNowPlaying()
 {
     if (gXReq3.readyState != 4)
         return;

     try
     {
         var jsonStr = gXReq3.responseText;
         var begin = jsonStr.indexOf('{');
         var end = jsonStr.lastIndexOf('}');
         var res = eval('(' + jsonStr.substring(begin, end + 1) + ')');

         switch (res.State)
         {
             case 0:  // Disconnected
                 {
                     SetClient("");
                     break;
                 }
             case 1:  // Playing
                 {
                     if (res.Duration <= 0 || res.Position < 0)
                     {
                         NPTIME.innerText = "NA";
                         NPTELAPSED.style.width = "0%";
                     }
                     else
                     {
                         NPTIME.innerText = FormatTime(res.Position) + " / " + FormatTime(res.Duration);
                         NPTELAPSED.style.width = (res.Position / res.Duration) * 100 + "%";
                     }

                     if (gNPState != res.State)
                     {
                         bar_play.style.display = "none";
                         bar_pause.style.display = "";
                     }
                     break;
                 }
             case 2:  // Paused
                 {
                     if (gNPState != res.State)
                     {
                         bar_play.style.display = "";
                         bar_pause.style.display = "none";
                     }
                     break;
                 }
             case 3:  // No media file loaded
                 {
                     NPTIME.innerText = "Not playing";
                     NPTELAPSED.style.width = "0%";
                     NPINFO.innerHTML = "";
                     if (gNPState != res.State)
                     {
                         bar_play.style.display = "none";
                         bar_pause.style.display = "";
                     }
                     break;
                 }
         }

         gNPState = res.State;
         if (gNPMediaID != res.ID)
         {
             gNPMediaID = res.ID;
             UpdateNPInfo();
         }

     }
     catch (err)
     {
         SetClient("");
        // ReportConnectionError3();
         // DISKTEXT.innerHTML = err;
     }
 }

 function UpdateNPInfo()
 {
     try
     {
         if (gNPMediaID == "")
         {
             NPINFO.innerHTML = "";
         }
         else
         {
             if (gXReq4 == null)
             {
                 gXReq4 = new XMLHttpRequest();
                 gXReq4.onreadystatechange = FillNPInfo;
             }
             else if (gXReq4.readyState != 4)
                 return;

             gXReq4.open("GET", "http://" + gUser + ":" + gPass + "@" + gServer + ":" + gPort + MEDIAFILE_URL + "&context=" + gClient + "&NoCache=" + Math.random(), true);
             gXReq4.send();
         }
     }
     catch (err)
     {
         // NPINFO.innerHTML = err.Description;
         NPINFO.innerHTML = "NA";
     }
}

function FillNPInfo()
{
    if (gXReq4.readyState != 4)
        return;

    try
    {
        var res = eval('(' + gXReq4.responseText + ')');
        if (res == null || res.MediaFile == null)
        {
            NPINFO.innerHTML = gNPMediaID;
        }
        else
        {
            var mf = res.MediaFile;
            NPINFO.innerHTML = eval('(' + gNPString + ')');
        }
    }
    catch (err)
    {
        NPINFO.innerHTML = err.name + ": " + err.description;
    }
}

 function SetClient(client)
 {
     gNPState = 0;
     gNPMediaID = "";

     if (client != "")
     {
         clearTimeout(NPCONTENT.timer);
         gClient = client;
         var name = GetClientName(gClient);
         NPCLIENT.innerText = '(' + (name != "" ? name : gClient) + ')';
         PollNP();
         NPCONTENT.timer = setInterval(PollNP, gNPUpdateSec * 1000);
         NPTBAR.style.visibility = "visible";
     }
     else
     {
         NPTIME.innerHTML = "";
         NPTELAPSED.style.width = "0%";
         NPTBAR.style.visibility = "hidden";
         NPINFO.innerHTML = "";
         clearTimeout(NPCONTENT.timer);
         if (gClient != "" && gNPConnectSec > 0)
         {
             var name = GetClientName(gClient);
             NPCLIENT.innerText = "Waiting for " + (name != "" ? name : gClient) + "...";
             NPCONTENT.timer = setInterval(DownloadAllClients, gNPConnectSec * 1000);
         }
         else
         {
             NPCLIENT.innerText = "Select client...";
             gClient = "";
         }
     }
 }

 function DownloadAllClients()
 {
     try
     {

         if (gXReq6 == null)
         {
             gXReq6 = new XMLHttpRequest();
             gXReq6.onreadystatechange = CheckClientConnection;
         }
         else if (gXReq6.readyState != 4)
             return;

         gXReq6.open("GET", "http://" + gUser + ":" + gPass + "@" + gServer + ":" + gPort + CLIENTS_URL + "&NoCache=" + Math.random(), true);
         gXReq6.send();
     }
     catch (err)
     {
         ReportConnectionError();
         //  MAINCONTENT.innnerText = err;
     }
 }

 function CheckClientConnection()
 {
     if (gXReq6.readyState != 4)
         return;

     try
     {
         var res = eval('(' + gXReq6.responseText + ')');
         var clients = res.Result;
         for (var i = 0; i < clients.length; i++)
         {
             if (clients[i] == gClient || (gClient.charAt(0) == '/' && gClient.split(':')[0] == clients[i].split(':')[0]))
             {
                 SetClient(clients[i]);
                 break;
             }
         }
     }
     catch (err)
     {
         
     }
 }

 function GetClientName(client)
 {
     try
     {
         var strings = System.Gadget.Settings.readString("ClientNames").split(';');
         if (strings.length < 2)
             return "";

         for (i = 0; i < strings.length; i += 2)
         {
             if (strings[i] == client)
                 return strings[i + 1];
             else if (client.charAt(0) == '/')
             {
                 if (client.split(':')[0] == strings[i])
                     return strings[i + 1];
             }
         }
     }
     catch (err)
     {
     }

     return "";
 }

 function FormatTime(ms)
 {
     var str = "";
     var time = Math.round(ms / 1000);
     var min = parseInt(time / 60);
     var hr = parseInt(min / 60);
     var sec = time % 60;

     if (hr > 0)
     {
         str += hr + ":";
         min = min - (hr * 60);
     }

     if (min < 10 && hr > 0)
         str += "0" + min + ":";
     else
         str += min + ":";
    
     if (sec < 10)
         str += "0" + sec;
     else
         str += sec;
     return str;
 }

function ReportConnectionError()
{
    CURRENT.innerHTML = ERROR1;
}

function ReportConnectionError2()
{
    DISKTEXT.innerText = "NA";
    DISKUSED.style.width = "100%";
}

function ReportConnectionError3()
{
    NPTIME.innerText = "NA";
}


//////////////////////////////////////////////////////////////////////////////////////////////////////////
// For the options/settings

function SettingsClosed(event)
{
    if (event.closeAction == event.Action.commit)
    {
        ApplySettings();
    }
}

function ApplySettings()
{
    // If the settings aren't saved yet, write defaults, otherwise load them
    var str = System.Gadget.Settings.readString( "Background");
    if( str == "")
        System.Gadget.Settings.write("Background", gBackgroundImg);
    else
    	gBackgroundImg = str;
        
    str = System.Gadget.Settings.readString( "Size");
    if( str == "")
        System.Gadget.Settings.writeString("Size", gNumRecs);    
    else
    {
        try
        {
            gNumRecs = parseInt( str);
            if( gNumRecs < 1 || gNumRecs > 12)
               gNumRecs = 3;
        }
        catch( err)
        {
            gNumRecs = 3;   
        }
    }

    str = System.Gadget.Settings.readString("Width");
    if (str == "")
        System.Gadget.Settings.writeString("Width", gTotalWidth);
    else
    {
        try
        {
            gTotalWidth = parseInt(str);
            if (gTotalWidth < 130 || gTotalWidth > 300)
                gTotalWidth = 130;
        }
        catch (err)
        {
            gTotalWidth = 130;
        }
    }

    str = System.Gadget.Settings.readString("ShowDisk");
    if (str == "")
        System.Gadget.Settings.write("ShowDisk", true);
    else
        gShowDisk = (str == "True");

    DISKCONTENT.style.display = gShowDisk ? "block" : "none";

    str = System.Gadget.Settings.readString("ShowNowPlaying");
    if (str == "")
        System.Gadget.Settings.write("ShowNowPlaying", gShowNP);
    else
        gShowNP = (str == "True");

    NPCONTENT.style.display = gShowNP ? "block" : "none";
    if (!gShowNP)
        gClient = "";

    str = System.Gadget.Settings.readString("NPHeight");
    if (str == "")
        System.Gadget.Settings.writeString("NPHeight", gNPDetailsHeight);
    else
    {
        try
        {
            gNPDetailsHeight = parseInt(str);
            if (gNPDetailsHeight < 55 || gNPDetailsHeight > 2000)
                gNPDetailsHeight = 55;
        }
        catch (err)
        {
            gNPDetailsHeight = 55;
        }
    }

    str = System.Gadget.Settings.readString("RecHeight");
    if (str == "")
        System.Gadget.Settings.writeString("RecHeight", gRecHeight);
    else
    {
        try
        {
            gRecHeight = parseInt(str);
            if (gRecHeight < 30 || gRecHeight > 200)
                gRecHeight = 30;
        }
        catch (err)
        {
            gRecHeight = 30;
        }
    }

    // Compute heights
    gTotalHeight = gBaseHeight + gHeaderHeight + gRecHeight * gNumRecs;
    if (gShowDisk)
        gTotalHeight += gDiskHeight;
    if (gShowNP)
        gTotalHeight += gNPBaseHeight + gNPDetailsHeight;
        
    str = System.Gadget.Settings.readString( "Margins");
    if( str == "")
    {
        System.Gadget.Settings.writeString("Margins", "0 0 0 0");
        MAINCONTENT.style.height = gTotalHeight;    
    }
    else
    {
        try
        {
            var strings = str.split(" ");
            var margins = new Array( parseInt(strings[0]), parseInt(strings[1]), parseInt(strings[2]), parseInt(strings[3]) );
            MAINCONTENT.style.margin = margins[0] + " " + margins[1] + " " + margins[2] + " " + margins[3];
            MAINCONTENT.style.width = gTotalWidth - margins[1] - margins[3];
            MAINCONTENT.style.height = gTotalHeight;
            gTotalHeight += margins[0] + margins[2];
        }
        catch(err){}
    }

    str = System.Gadget.Settings.readString("Border");
    if (str == "")
        System.Gadget.Settings.write("Border", true);
    else
    {
        MAINCONTENT.style.borderStyle = System.Gadget.Settings.read("Border") ? gBorder : "none";
    }  
    
    str = System.Gadget.Settings.readString( "Server");
    if( str == "")
        System.Gadget.Settings.writeString("Server", gServer);
    else
    	gServer = str;
    	
    str = System.Gadget.Settings.readString( "Port");
    if( str == "")
        System.Gadget.Settings.writeString("Port", gPort);
    else
    	gPort = str;
    	
    str = System.Gadget.Settings.readString( "DateFormat");
    if( str == "")
        System.Gadget.Settings.writeString("DateFormat", gDateFormat);
    else
    	gDateFormat = str;
    	
    str = System.Gadget.Settings.readString( "TimeFormat");
    if( str == "")
        System.Gadget.Settings.writeString("TimeFormat", gTimeFormat);
    else
    	gTimeFormat = str;
    	
    str = System.Gadget.Settings.readString( "Update");
    if( str == "")
        System.Gadget.Settings.write("Update", gUpdateMinutes);
    else
    {
    	try
        {
            gUpdateMinutes = parseInt( str);
            if( gUpdateMinutes < 1)
                gUpdateMinutes = 5;
        }
        catch( err)
        {
            gUpdateMinutes = 5;   
        }
    }
    
    str = System.Gadget.Settings.readString( "User");
    if( str == "")
        System.Gadget.Settings.writeString("User", gUser);
    else
    	gUser = str;
    	
    str = System.Gadget.Settings.readString( "Pass");
    if( str == "")
        System.Gadget.Settings.writeString("Pass", gPass);
    else
    	gPass = str;
    
    str = System.Gadget.Settings.readString( "LaunchType");
    str = System.Gadget.Settings.readString( "LaunchType");
    if( str == "")
        System.Gadget.Settings.writeString("LaunchType", "0");    
    else
    {
        try
        {
            gLaunchType = parseInt( str);
            if( gLaunchType < 0 || gLaunchType > 3)
                gLaunchType = 0;
        }
        catch( err)
        {
            gLaunchType = 0;   
        }
    }

    str = System.Gadget.Settings.readString("Logos");
    if (str == "")
        System.Gadget.Settings.write("Logos", false);
    else 
        gShowLogos = (str == "True");

    str = System.Gadget.Settings.readString("Padding");
    if (str == "")
        System.Gadget.Settings.write("Padding", false);
    else
        gAddPadding = (str == "True");

    str = System.Gadget.Settings.readString("NPUpdate");
    if (str == "")
        System.Gadget.Settings.write("NPUpdate", gNPUpdateSec);
    else
    {
        try
        {
            gNPUpdateSec = parseInt(str);
            if (gNPUpdateSec < 1)
                gNPUpdateSec = 5;
        }
        catch (err)
        {
            gNPUpdateSec = 5;
        }
    }

    str = System.Gadget.Settings.readString("NPString");
    if (str == "")
        System.Gadget.Settings.writeString("NPString", gNPString);
    else
        gNPString = str;

    str = System.Gadget.Settings.readString("NPConnect");
    if (str == "")
        System.Gadget.Settings.writeString("NPConnect", gNPConnectSec);
    else
    {
        try
        {
            gNPConnectSec = parseInt(str);
            if (gNPConnectSec < 0)
                gNPConnectSec = 0;
        }
        catch (err)
        {
            gNPConnectSec = 0;
        }
    }

    str = System.Gadget.Settings.readString("RecString");
    if (str == "")
        System.Gadget.Settings.writeString("RecString", gRecString);
    else
        gRecString = str;

    // Set up size
    document.body.style.height = gTotalHeight;
    document.body.style.width = gTotalWidth;
    RECORDCONTENT.style.height = gHeaderHeight + gRecHeight * gNumRecs;
    NPCONTENT.style.height = gNPBaseHeight + gNPDetailsHeight;
    NPINFO.style.height = gNPDetailsHeight;
   
    // Set up background
    BKGD.src = gBackgroundImg;
    BKGD.style.width = gTotalWidth;
    BKGD.style.height = gTotalHeight;
    bar.style.top = gTotalHeight - 27;

    // Make sure Now Playing details are updated
    gNPMediaID = "";
    
     // Update/connect in 3 seconds
     if( RECORDCONTENT.timer != null)
        clearTimeout( RECORDCONTENT.timer);
     RECORDCONTENT.timer = setInterval(ConnectAndSetTimer, 3000);
}

function ConnectAndSetTimer()
{
    if( RECORDCONTENT.timer != null)
        clearTimeout( RECORDCONTENT.timer);
     RECORDCONTENT.timer = setInterval(ConnectToSage, gUpdateMinutes*60*1000);

     ConnectToSage();

     // Now playing
     if (gShowNP)
         SetClient(gClient);
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////
// For flyout
function ShowFlyout() 
{
    try
    {
        if( System.Gadget.Flyout.show)
        {
            System.Gadget.Flyout.show = false;
        }
        else
        {

            System.Gadget.Flyout.onShow = function() { SetFlyout(); }
            System.Gadget.Flyout.show = true;
            
            // Update/connect in 2 seconds
            if( RECORDCONTENT.timer != null)
                clearTimeout( RECORDCONTENT.timer);
            RECORDCONTENT.timer = setInterval(ConnectAndSetTimer, 2000);
        }
    }
    catch( err)
    {
        //PN.innerText = err.Description;
    }
}

function SetFlyout() 
{
    System.Gadget.Flyout.document.parentWindow.Init("http://" + gUser + ":" + gPass + "@" + gServer + ":" + gPort + SCHEDULE_URL + "&size=500&NoCache=" + Math.random(), gDateFormat, gTimeFormat, gShowLogos ? "http://" + gServer + ":" + gPort + CHLOGO_URL : "", gAddPadding);
    System.Gadget.Flyout.document.parentWindow.DownloadSchedule();
}

function ShowFlyout2()
{
    try
    {
        if (System.Gadget.Flyout.show)
        {
            System.Gadget.Flyout.show = false;
        }
        else
        {

            System.Gadget.Flyout.onShow = function () { SetFlyout2(); }
            System.Gadget.Flyout.show = true;
        }
    }
    catch (err)
    {
        //PN.innerText = err.Description;
    }
}

function SetFlyout2()
{
    System.Gadget.Flyout.document.parentWindow.Init2("http://" + gUser + ":" + gPass + "@" + gServer + ":" + gPort + CLIENTS_URL + "&NoCache=" + Math.random());
    System.Gadget.Flyout.document.parentWindow.DownloadClients();
}

function GetInstallDirFromReg() 
{
    try 
    {
        var shellobj = new ActiveXObject("WScript.Shell");
        return shellobj.RegRead(REG_INSTALL);
    }
    catch (Error) 
    {
        try 
        {
            var shellobj2 = new ActiveXObject("WScript.Shell");
            return shellobj2.RegRead(REG_INSTALL_64);
        }
        catch (Error2) 
        {
            return "";
        }
    }
}

function HeaderRefresh()
{
  CURRENTHEADER.innerText = "Click to Refresh...";
}

function HeaderNormal()
{
  CURRENTHEADER.innerText = "Recording Schedule";
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////
// The routines below were mostly "borrowed" from the SlideShow Gadget for a consistent control bar.

////////////////////////////////////////////////////////////////////////////////
//
// creates navigation bar
//
////////////////////////////////////////////////////////////////////////////////
function makeBar(controlsString)
{
    var controlsArray = controlsString.innerText.split(" ");
    var controlName;
    var newImageToAdd;
    var newLabelToAdd;
    var labelsForRollovers = "";
    var imageRollovers = "<div id='backBar'></div><div id='topBar'>";
    var i = 0;
    while (controlName = controlsArray[i++])
    {
        var controlNameAction = controlName;
        if (controlName == "-")
        {
            newImageToAdd = "";
        }
        else
        {
            newImageToAdd = "<a id='link_" + controlNameAction + "' href='javascript:void(0);' onClick='this.blur();'>"
                + "<img border=0 id='bar_" + controlNameAction + "' hspace='3' src='images/" + controlName + "_rest.png' "
                + "onMouseOver='src=\"images/" + controlName + "_hov.png\"' onMouseOut='src=\"images/" + controlName + "_rest.png\"' "
                + "onMouseDown='src=\"images/" + controlName + "_down.png\"' onMouseUp='src=\"images/" + controlName + "_hov.png\";"
                + "onAction(\"" + controlNameAction + "\");' \>"
                + "</a>";
            newLabelToAdd = "<label for='link_" + controlName + "'>" + controlName + "</label>";
        }
        imageRollovers += newImageToAdd;
        labelsForRollovers += newLabelToAdd;
    }
    imageRollovers += "</div>";
    controlsString.innerHTML = imageRollovers;
}

////////////////////////////////////////////////////////////////////////////////
//
// show navigation bar with fade-in
//
////////////////////////////////////////////////////////////////////////////////
function showBar()
{
//    if (event.fromElement)
//    {
//        return;
//    }
    clearTimeout(bar.timer);
    up();
}
////////////////////////////////////////////////////////////////////////////////
//
// hide navigation bar with fade-out
//
////////////////////////////////////////////////////////////////////////////////
function hideBar()
{
//    if (event.toElement)
//    {
//        return;
//    }
    clearTimeout(bar.timer);
    down();
    bar.blur();

}

function up()
{
    with (bar.filters("alpha"))
    {
        if ((opacity += 15) < 75)
        {
            bar.timer = setTimeout(up, 25);
        }
        else
        {
            opacity = 75;
        }
    }
}

function down()
{
    with (bar.filters("alpha"))
    {
        if ((opacity -= 15) > 0)
        {
            bar.timer = setTimeout(down, 25);
        }
        else
        {
            opacity = 0;
        }
    }
}

// Respond to control bar button clicks
function onAction(action)
{
    if (event.button == 1 && gClient != "")
    {
        try
        {
            if (gXReq5 == null)
            {
                gXReq5 = new XMLHttpRequest();
                gXReq5.onreadystatechange = function ()
                {
   
                };
            }
            else if (gXReq5.readyState != 4)
                return;

            switch (action)
            {
                case "prev":
                    gXReq5.open("GET", "http://" + gUser + ":" + gPass + "@" + gServer + ":" + gPort + PREV_URL + "&context=" + gClient + "&NoCache=" + Math.random(), true);
                    gXReq5.send();
                    break;
                case "play":
                case "pause":
                    gXReq5.open("GET", "http://" + gUser + ":" + gPass + "@" + gServer + ":" + gPort + PP_URL + "&context=" + gClient + "&NoCache=" + Math.random(), true);
                    gXReq5.send();
                    break;
                case "next":
                    gXReq5.open("GET", "http://" + gUser + ":" + gPass + "@" + gServer + ":" + gPort + NEXT_URL + "&context=" + gClient + "&NoCache=" + Math.random(), true);
                    gXReq5.send();
                    break;
                case "reveal":
                    //ShowFlyout2();
                    break;
            }
        }
        catch (err)
        {
            
        }
    }

}

